/*
 * 商户
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MerchantInfoController : BaseController
    {
        public MerchantInfoController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }

        #region 商户列表

        /// <summary>
        /// 根据条件查询商户列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MerchantInfo data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询商户列表

        /// <summary>
        /// 商户列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MerchantInfo data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("Name", "1"); //名称
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("Mobile", "1"); //手机号
            Fields.Add("IsAuth", "1"); //是否认证


            string condition = " and Status>0";


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MerchantInfo", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["IsAuthName"] = dic["IsAuth"].ToString() == "1" ? "是" : "否";

            }
            return Json(obj);
        }

        #endregion

        #region 增加商户

        /// <summary>
        /// 增加或修改商户信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加商户

        /// <summary>
        /// 增加或修改商户信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MerchantInfo data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Name", data.Name); //名称
            Fields.Add("Mobile", data.Mobile); //手机号
            Fields.Add("Areas", data.Areas); //所在地区
            Fields.Add("Address", data.Address); //详细地址
            Fields.Add("IsAuth", data.IsAuth); //是否认证
            Fields.Add("TotalAmount", data.TotalAmount); //平台总收益
            Fields.Add("TotalOrder", data.TotalOrder); //累计订单
            Fields.Add("TotalCustomer", data.TotalCustomer); //累计客户
            Fields.Add("TotalUser", data.TotalUser); //会员数
            Fields.Add("LoginPwd", function.MD532(data.LoginPwd)); //登录密码

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Add("MerchantInfo", Fields, 0);
            AddSysLog(data.Id.ToString(), "MerchantInfo", "add");
            db.SaveChanges();

            SetRedis(Id);


            return "success";
        }

        #endregion

        #region 修改商户

        /// <summary>
        /// 增加或修改商户信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            MerchantInfo editData = db.MerchantInfo.FirstOrDefault(m => m.Id == Id) ?? new MerchantInfo();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商户

        /// <summary>
        /// 增加或修改商户信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MerchantInfo data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Name", data.Name); //名称
            Fields.Add("Mobile", data.Mobile); //手机号
            Fields.Add("Areas", data.Areas); //所在地区
            Fields.Add("Address", data.Address); //详细地址
            Fields.Add("IsAuth", data.IsAuth); //是否认证
            Fields.Add("TotalAmount", data.TotalAmount); //平台总收益
            Fields.Add("TotalOrder", data.TotalOrder); //累计订单
            Fields.Add("TotalCustomer", data.TotalCustomer); //累计客户
            Fields.Add("TotalUser", data.TotalUser); //会员数
            if (!string.IsNullOrEmpty(data.LoginPwd)) //密码不为空就修改密码，否则不操作
            {
                Fields.Add("LoginPwd", function.MD532(data.LoginPwd)); //登录密码
            }

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantInfo", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "MerchantInfo", "update");
            db.SaveChanges();

            SetRedis(data.Id);

            return "success";
        }

        #endregion

        #region 删除商户信息

        /// <summary>
        /// 删除商户信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MerchantInfo", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantInfo", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MerchantInfo", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantInfo", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MerchantInfo", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantInfo", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Sort("MerchantInfo", Sort, Id);

            AddSysLog(Id.ToString(), "MerchantInfo", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.MerchantInfo.Add(new MerchantInfo()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "MerchantInfo", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MerchantInfo data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Name", "1"); //名称
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("Mobile", "1"); //手机号
            Fields.Add("IsAuth", "1"); //是否认证


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MerchantInfo", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["IsAuthName"] = dic["IsAuth"].ToString() == "1" ? "是" : "否";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MerchantInfo", "ExportExcel");
            return Json(result);
        }

        #endregion






        #region 设置缓存

        private void SetRedis(int Id = 0)
        {
            if (Id > 0)
            {
                MerchantInfo merchant = db.MerchantInfo.FirstOrDefault(m => m.Id == Id) ?? new MerchantInfo();
                RedisDbconn.Instance.Set("MerchantInfo:" + Id, merchant);

                MerchantForMobile forMobile = db.MerchantForMobile.FirstOrDefault(m => m.Mobile == merchant.Mobile);
                if (forMobile == null)
                {
                    forMobile = db.MerchantForMobile.Add(new MerchantForMobile()
                    {
                        Mobile = merchant.Mobile,
                        MerchantId = Id,
                    }).Entity;
                }
                RedisDbconn.Instance.Set("MerchantForMobile:" + merchant.Mobile, forMobile);
            }
        }

        #endregion
    }
}
